//
// ListIter.java : ꥹȤ˼ФΥ饹
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

final class ListIter {
  // ֤ѥХå󥿡ե饹
  abstract static class cb {
    Environment env ;
    Object arg = SAtom.nil ,
           result = SAtom.nil ;  // ѿdoeach ͤˤʤ롣
    cb(Environment x) {env = x ;} 
    cb(Environment x,Object a) {env = x ; arg = a ;}
    abstract boolean repeat(Object o) throws Exception ; // ͤ
  } ;

  int count ;
  Object o = SAtom.nil,last = SAtom.nil ;

  ListIter(Object x) { o = x ; count = 0 ;}

  // ֤(o Ͽʤʤ)
  Object doeach(String msg,ListIter.cb cb) throws Exception {
    Object start = o,i = o ;
    while (i != SAtom.nil) {
      if (i instanceof Cons) {
        Cons c = (Cons)i ;
        if (!cb.repeat(c.car)) break ; // ͤΤȤ
        i = c.cdr ;
        if (i == start) break ;
      } else {
        throw new EvalException(msg+" : Illeagal Argument list") ;
      }
    }
    return cb.result ;
  }

  // ʤǤäƤ֤
  Object getNextObjForce() {
    if (!(o instanceof Cons)) {
      last = o ;
      return last ;
    }
    count++ ;
    last = ((Cons)o).car ;
    o = ((Cons)o).cdr ;
    return last ;
  }

  // ()֤
  Object getNextObj(String msg) throws EvalException {
    if (!(o instanceof Cons)) {
      throw new EvalException(msg+" : Too Few Arguments") ;
    }
    count++ ;
    last = ((Cons)o).car ;
    o = ((Cons)o).cdr ;
    return last ;
  }

  // (ǽ)֤
  Object getFinalObj(String msg) throws EvalException {
    last = getNextObj(msg) ;
    if (o != SAtom.nil) throw new EvalException(msg+" : Too Much Arguments") ;
    return last ;
  }

  // ()ɾ֤
  Object getNextObjEval(String msg,Environment e) throws Exception {
    last = Eval.eval(getNextObj(msg),e) ;
    return last ;
  }

  // ()ɾơCons Ǥ֤
  Cons getNextConsEval(String msg,Environment e) throws Exception {
    last = Evalutil.mustbecons(msg+" :",Eval.eval(getNextObj(msg),e)) ;
    return (Cons)last ;
  }

  // () SAtom Ǥ֤
  SAtom getNextSAtom(String msg) throws EvalException {
    last = getNextObj(msg) ;
    if (!(last instanceof SAtom)) {
      throw new EvalException(msg+" : Arg "+count+" must be SAtom") ;
    }
    return (SAtom)last ;
  }

  // (ǽ)ɾ֤
  Object getFinalObjEval(String msg,Environment e) throws Exception {
    last = Eval.eval(getFinalObj(msg),e) ;
    return last ;
  }

  // ĤǤޤȤ֤
  Object getRest() {
    return o ;
  }

  // ĤǤɾΤޤȤ֤
  // (Evalutil.evalall Vector Ȥʤ롼פ 1 ŤʤΤǹ®
  //  ɾǼԤ硢Ķ˱ƶĤ)
  Object getRestEval(String msg,Environment e) throws Exception {
    Object start = o,res = SAtom.nil ;
    Cons l = null ;

    while (o != SAtom.nil) {
      if (o instanceof Cons) {
        Object a = ((Cons)o).car,d = ((Cons)o).cdr ;
        Cons n = new Cons(Eval.eval(a,e),SAtom.nil) ; // 󥹤
        if (l != null) { // 줬ǤǤʤʤ
          l.cdr = n ;    // Υ cdr ˿ؤΥݥ󥿤򤤤
        } else {
          res = n ;      // Ǥʤ顢ꥹȤƬͤȤƵ
        }
        l = n ;          // Τ˵
        o = d ;
        if (o == start) break ; // ۴ĥꥹȡ
      } else {
        throw new EvalException(msg+" : Invalid list") ;
      }
    }

    last = res ;
    return res ;
  }
}
