//
// Sloader.java : S Υ
//
//              This is a part of miolisp sourcefile
//              Copyright (C) 1998  Nishiyama, Naoki / Mio software lab. 
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import java.io.* ;

class Sloader {
  public static Object load(Environment e,String s) throws Exception {
    Object a = null ;
    Sreader sr = new Sreader(new FileInputStream(s)) ;
    while (true) {
      try {
        a = sr.read() ;
        Eval.eval(a,e) ;
      } catch(Exception ex) {
        if (ex instanceof SreaderException) {
          if (ex.getMessage().equals("Sexpr not ended at EOF")) {
            return SAtom.t ;
          }
        }
        System.out.println("Error while loading>"+Sexpr.toStr(a)) ;
        throw ex ;
      }
    }
  }
}
